/***************************************************************************
                          jmbeq.h  -  description
                             -------------------
    begin                : Mon Jun 16 20:12:07 CEST 2006
    copyright            : (C) 2006 by Nicola Doebelin
    email                : nicola@doebelin.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <QDialog>
#include <QWidget>
#include <QEvent>
#include <QStringList>
#include <QPoint>
#include <QList>

#include "eqband.h"

using namespace std;

class JmbEq : public QDialog
{
	public:
		JmbEq(QWidget * parent = 0, Qt::WFlags f = 0);
		~JmbEq();

	private:
		void resizeEvent(QResizeEvent *);
		void paintEvent(QPaintEvent *);
		void mouseMoveEvent(QMouseEvent *);
		void keyPressEvent(QKeyEvent *);
		void keyReleaseEvent(QKeyEvent *);

		void drawGrid();
		void drawText();
		void calcEqCurve();
		void reset();
		void toggleMode();
		void setOutputGain(float f)	{ oGain = f; };
		float outputGain()		{ return oGain; };

		float xToFreq(int);
		float yToLevel(int);
		float f_freqToX(float);
		float f_levelToY(float);
		int   freqToX(float);
		int   levelToY(float);

		QList<EqBand> filterList;
		QStringList	filterKeys,
				helpKeys;
		EqBand *activeBand;

		QPoint	startPos,
			prevPos,
			cursorPos;

		bool	hasActiveBand,
			ignoreMove;

		QList<QPointF> curvePoints;

		float	lastQ,
			oGain;

		enum Action{ NONE,
		             GAIN,
		             FREQ,
		             DRAG,
		             BW,
		             MASTERGAIN } activeAction;

};


/* EOF */
